C----------------------------------------------------------------------
      FUNCTION ran2(idum)
      INTEGER idum,IM1,IM2,IMM1,IA1,IA2,IQ1,IQ2,IR1,IR2,NTAB,NDIV
      REAL*8 ran2,AM,EPS,RNMX
      PARAMETER(IM1=2147483563,IM2=2147483399,AM=1.0D0/IM1)
      PARAMETER(IMM1=IM1-1,IA1=40014,IA2=40692,IQ1=53668)
      PARAMETER(IQ2=52774,IR1=12211,IR2=3791,NTAB=32)
      PARAMETER(NDIV=1+IMM1/NTAB,EPS=1.2D-07,RNMX=1.0D0-EPS)
C----------------------------------------------------------------------
C    Long period (>2x10d+18) random number generator of L'Ecuyer with
C    Bays-Durham shuffle and added safeguards.  Returns a random deviate
C    between 0.0 and 1.0 (exclusive of the endpoint values).  Call with
C    idum a negative integer to initialize; thereafter, do not alter
C    idum between successive deviates in a sequence.  RNMX should 
C    approximate the largest floating point value that is less than 1.
C----------------------------------------------------------------------
      INTEGER IDUM2,J,K,IV(NTAB),IY
      SAVE IV,IY,IDUM2
      DATA IDUM2/123456789/, IV/NTAB*0/, IY/0/
      if(idum .le. 0) then                    !Initialize
        idum=max(-idum,1)                     !Prevent idum=0
        idum2=idum
        do j=NTAB+8,1,-1                      !Load shuffle table
          k=idum/IQ1                          !(after 8 warm-ups).
          idum=IA1*(idum-k*IQ1)-k*IR1
          if(idum .lt. 0) idum=idum+IM1
          if(j .le. NTAB) iv(j)=idum
        end do
        iy=iv(1)
      end if
      k=idum/IQ1                      !Start here when not initializing.
      idum=IA1*(idum-k*IQ1)-k*IR1     !Compute idum=mod(IA1*idum,IM1)
      if(idum .lt. 0) idum=idum+IM1   !without overflows:Schrage's method.
      k=IDUM2/IQ2
      idum2=IA2*(idum2-k*IQ2)-k*IR2   !Compute idum2=mod(IA2*idum2,IM2).
      if(idum2 .lt. 0) idum2=idum2+IM2
      j=1+iy/NDIV                     !Will be in the range 1:NTAB.
      iy=iv(j)-idum2                  !Here idum is shuffled, idum & idum2
      iv(j)=idum                      !are combined to generate output.
      if(iy .lt. 1) iy=iy+IMM1
      ran2=min(AM*iy,RNMX)            !Because users don't expect endpoints
      return
      END
C===========================================================================
